diff -uNr openmp-3.5.0.src/runtime/src/z_Linux_util.c openmp-3.5.0.src.r219214/runtime/src/z_Linux_util.c
--- openmp-3.5.0.src/runtime/src/z_Linux_util.c	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/z_Linux_util.c	2014-10-24 19:58:41.000000000 -0400
@@ -1,7 +1,7 @@
 /*
  * z_Linux_util.c -- platform specific routines.
- * $Revision: 42847 $
- * $Date: 2013-11-26 09:10:01 -0600 (Tue, 26 Nov 2013) $
+ * $Revision: 43473 $
+ * $Date: 2014-09-26 15:02:57 -0500 (Fri, 26 Sep 2014) $
  */
 
 
@@ -21,6 +21,8 @@
 #include "kmp_str.h"
 #include "kmp_i18n.h"
 #include "kmp_io.h"
+#include "kmp_stats.h"
+#include "kmp_wait_release.h"
 
 #if !KMP_OS_FREEBSD
 # include <alloca.h>
@@ -654,7 +656,6 @@
         return TRUE;
     }
 #endif /* KMP_OS_LINUX || KMP_OS_FREEBSD */
-
     /* Use incremental refinement starting from initial conservative estimate */
     TCW_PTR(th->th.th_info.ds.ds_stacksize, 0);
     TCW_PTR(th -> th.th_info.ds.ds_stackbase, &stack_data);
@@ -679,6 +680,10 @@
 #ifdef KMP_TDATA_GTID
     __kmp_gtid = gtid;
 #endif
+#if KMP_STATS_ENABLED
+    // set __thread local index to point to thread-specific stats
+    __kmp_stats_thread_ptr = ((kmp_info_t*)thr)->th.th_stats;
+#endif
 
 #if USE_ITT_BUILD
     __kmp_itt_thread_name( gtid );
@@ -815,6 +820,7 @@
                 );
             }; // if
         }; // if
+        TCW_4( __kmp_global.g.g_time.dt.t_value, 0 );  // AC: free thread that waits for monitor started
     }
     #endif // KMP_REAL_TIME_FIX
 
@@ -859,14 +865,15 @@
 
         status = pthread_mutex_lock( & __kmp_wait_mx.m_mutex );
         KMP_CHECK_SYSFAIL( "pthread_mutex_lock", status );
-        status = pthread_cond_timedwait( & __kmp_wait_cv.c_cond, & __kmp_wait_mx.m_mutex,
-                                         & now );
-        if ( status != 0 ) {
-            if ( status != ETIMEDOUT && status != EINTR ) {
-                KMP_SYSFAIL( "pthread_cond_timedwait", status );
+        // AC: the monitor should not fall asleep if g_done has been set
+        if ( !TCR_4(__kmp_global.g.g_done) ) {  // check once more under mutex
+            status = pthread_cond_timedwait( &__kmp_wait_cv.c_cond, &__kmp_wait_mx.m_mutex, &now );
+            if ( status != 0 ) {
+                if ( status != ETIMEDOUT && status != EINTR ) {
+                    KMP_SYSFAIL( "pthread_cond_timedwait", status );
+                };
             };
         };
-
         status = pthread_mutex_unlock( & __kmp_wait_mx.m_mutex );
         KMP_CHECK_SYSFAIL( "pthread_mutex_unlock", status );
 
@@ -941,6 +948,25 @@
 
     th->th.th_info.ds.ds_gtid = gtid;
 
+#if KMP_STATS_ENABLED
+    // sets up worker thread stats
+    __kmp_acquire_tas_lock(&__kmp_stats_lock, gtid);
+
+    // th->th.th_stats is used to transfer thread specific stats-pointer to __kmp_launch_worker
+    // So when thread is created (goes into __kmp_launch_worker) it will
+    // set it's __thread local pointer to th->th.th_stats
+    th->th.th_stats = __kmp_stats_list.push_back(gtid);
+    if(KMP_UBER_GTID(gtid)) {
+        __kmp_stats_start_time = tsc_tick_count::now();
+        __kmp_stats_thread_ptr = th->th.th_stats;
+        __kmp_stats_init();
+        KMP_START_EXPLICIT_TIMER(OMP_serial);
+        KMP_START_EXPLICIT_TIMER(OMP_start_end);
+    }
+    __kmp_release_tas_lock(&__kmp_stats_lock, gtid);
+
+#endif // KMP_STATS_ENABLED
+
     if ( KMP_UBER_GTID(gtid) ) {
         KA_TRACE( 10, ("__kmp_create_worker: uber thread (%d)\n", gtid ) );
         th -> th.th_info.ds.ds_thread = pthread_self();
@@ -1087,6 +1113,8 @@
     th->th.th_info.ds.ds_gtid = KMP_GTID_MONITOR;
     #if KMP_REAL_TIME_FIX
         TCW_4( __kmp_global.g.g_time.dt.t_value, -1 ); // Will use it for synchronization a bit later.
+    #else
+        TCW_4( __kmp_global.g.g_time.dt.t_value, 0 );
     #endif // KMP_REAL_TIME_FIX
 
     #ifdef KMP_THREAD_ATTR
@@ -1155,8 +1183,6 @@
         }; // if
     #endif /* _POSIX_THREAD_ATTR_STACKSIZE */
 
-    TCW_4( __kmp_global.g.g_time.dt.t_value, 0 );
-
     status = pthread_create( &handle, & thread_attr, __kmp_launch_monitor, (void *) th );
 
     if ( status != 0 ) {
@@ -1228,9 +1254,11 @@
 __kmp_exit_thread(
     int exit_status
 ) {
-    pthread_exit( (void *) exit_status );
+    pthread_exit( (void *)(intptr_t) exit_status );
 } // __kmp_exit_thread
 
+void __kmp_resume_monitor();
+
 void
 __kmp_reap_monitor( kmp_info_t *th )
 {
@@ -1262,6 +1290,7 @@
 
     } else
     {
+        __kmp_resume_monitor();   // Wake up the monitor thread
         status = pthread_join( th->th.th_info.ds.ds_thread, & exit_val);
         if (exit_val != th) {
             __kmp_msg(
@@ -1540,7 +1569,7 @@
     __kmp_init_common = FALSE;
 
     TCW_4(__kmp_init_user_locks, FALSE);
-    __kmp_user_lock_table.used = 0;
+    __kmp_user_lock_table.used = 1;
     __kmp_user_lock_table.allocated = 0;
     __kmp_user_lock_table.table = NULL;
     __kmp_lock_blocks = NULL;
@@ -1638,62 +1667,54 @@
     }
 }
 
-/*
- * This routine puts the calling thread to sleep after setting the
- * sleep bit for the indicated spin variable to true.
+/* This routine puts the calling thread to sleep after setting the
+ * sleep bit for the indicated flag variable to true.
  */
-
-void
-__kmp_suspend( int th_gtid, volatile kmp_uint *spinner, kmp_uint checker )
+template <class C>
+static inline void __kmp_suspend_template( int th_gtid, C *flag )
 {
+    KMP_TIME_BLOCK(USER_suspend);
     kmp_info_t *th = __kmp_threads[th_gtid];
     int status;
-    kmp_uint old_spin;
+    typename C::flag_t old_spin;
 
-    KF_TRACE( 30, ("__kmp_suspend: T#%d enter for spin = %p\n", th_gtid, spinner ) );
+    KF_TRACE( 30, ("__kmp_suspend_template: T#%d enter for flag = %p\n", th_gtid, flag->get() ) );
 
     __kmp_suspend_initialize_thread( th );
 
     status = pthread_mutex_lock( &th->th.th_suspend_mx.m_mutex );
     KMP_CHECK_SYSFAIL( "pthread_mutex_lock", status );
 
-    KF_TRACE( 10, ( "__kmp_suspend: T#%d setting sleep bit for spin(%p)\n",
-                    th_gtid, spinner ) );
+    KF_TRACE( 10, ( "__kmp_suspend_template: T#%d setting sleep bit for spin(%p)\n",
+                    th_gtid, flag->get() ) );
 
     /* TODO: shouldn't this use release semantics to ensure that __kmp_suspend_initialize_thread
        gets called first?
     */
-    old_spin = KMP_TEST_THEN_OR32( (volatile kmp_int32 *) spinner,
-                                     KMP_BARRIER_SLEEP_STATE );
-
-    KF_TRACE( 5, ( "__kmp_suspend: T#%d set sleep bit for spin(%p)==%d\n",
-                   th_gtid, spinner, *spinner ) );
+    old_spin = flag->set_sleeping();
 
-    if ( old_spin == checker ) {
-        KMP_TEST_THEN_AND32( (volatile kmp_int32 *) spinner, ~(KMP_BARRIER_SLEEP_STATE) );
+    KF_TRACE( 5, ( "__kmp_suspend_template: T#%d set sleep bit for spin(%p)==%d\n",
+                   th_gtid, flag->get(), *(flag->get()) ) );
 
-        KF_TRACE( 5, ( "__kmp_suspend: T#%d false alarm, reset sleep bit for spin(%p)\n",
-                       th_gtid, spinner) );
+    if ( flag->done_check_val(old_spin) ) {
+        old_spin = flag->unset_sleeping();
+        KF_TRACE( 5, ( "__kmp_suspend_template: T#%d false alarm, reset sleep bit for spin(%p)\n",
+                       th_gtid, flag->get()) );
     } else {
-
         /* Encapsulate in a loop as the documentation states that this may
          * "with low probability" return when the condition variable has
          * not been signaled or broadcast
          */
         int deactivated = FALSE;
-        TCW_PTR(th->th.th_sleep_loc, spinner);
-        while ( TCR_4( *spinner ) & KMP_BARRIER_SLEEP_STATE ) {
+        TCW_PTR(th->th.th_sleep_loc, (void *)flag);
+        while ( flag->is_sleeping() ) {
 #ifdef DEBUG_SUSPEND
             char buffer[128];
             __kmp_suspend_count++;
             __kmp_print_cond( buffer, &th->th.th_suspend_cv );
-            __kmp_printf( "__kmp_suspend: suspending T#%d: %s\n", th_gtid, buffer );
+            __kmp_printf( "__kmp_suspend_template: suspending T#%d: %s\n", th_gtid, buffer );
 #endif
-
-            //
-            // Mark the thread as no longer active
-            // (only in the first iteration of the loop).
-            //
+            // Mark the thread as no longer active (only in the first iteration of the loop).
             if ( ! deactivated ) {
                 th->th.th_active = FALSE;
                 if ( th->th.th_active_in_pool ) {
@@ -1720,11 +1741,11 @@
             now.tv_sec  += msecs / 1000;
             now.tv_nsec += (msecs % 1000)*1000;
 
-            KF_TRACE( 15, ( "__kmp_suspend: T#%d about to perform pthread_cond_timedwait\n",
+            KF_TRACE( 15, ( "__kmp_suspend_template: T#%d about to perform pthread_cond_timedwait\n",
                             th_gtid ) );
             status = pthread_cond_timedwait( &th->th.th_suspend_cv.c_cond, &th->th.th_suspend_mx.m_mutex, & now );
 #else
-            KF_TRACE( 15, ( "__kmp_suspend: T#%d about to perform pthread_cond_wait\n",
+            KF_TRACE( 15, ( "__kmp_suspend_template: T#%d about to perform pthread_cond_wait\n",
                                th_gtid ) );
 
             status = pthread_cond_wait( &th->th.th_suspend_cv.c_cond, &th->th.th_suspend_mx.m_mutex );
@@ -1735,28 +1756,23 @@
             }
 #ifdef KMP_DEBUG
             if (status == ETIMEDOUT) {
-                if ( (*spinner) & KMP_BARRIER_SLEEP_STATE ) {
-                    KF_TRACE( 100, ( "__kmp_suspend: T#%d timeout wakeup\n", th_gtid ) );
+                if ( flag->is_sleeping() ) {
+                    KF_TRACE( 100, ( "__kmp_suspend_template: T#%d timeout wakeup\n", th_gtid ) );
                 } else {
-                    KF_TRACE( 2, ( "__kmp_suspend: T#%d timeout wakeup, sleep bit not set!\n",
+                    KF_TRACE( 2, ( "__kmp_suspend_template: T#%d timeout wakeup, sleep bit not set!\n",
                                    th_gtid ) );
                 }
-            } else if ( (*spinner) & KMP_BARRIER_SLEEP_STATE ) {
-                KF_TRACE( 100, ( "__kmp_suspend: T#%d spurious wakeup\n", th_gtid ) );
+            } else if ( flag->is_sleeping() ) {
+                KF_TRACE( 100, ( "__kmp_suspend_template: T#%d spurious wakeup\n", th_gtid ) );
             }
 #endif
-
         } // while
 
-        //
-        // Mark the thread as active again
-        // (if it was previous marked as inactive)
-        //
+        // Mark the thread as active again (if it was previous marked as inactive)
         if ( deactivated ) {
             th->th.th_active = TRUE;
             if ( TCR_4(th->th.th_in_pool) ) {
-                KMP_TEST_THEN_INC32(
-                  (kmp_int32 *) &__kmp_thread_pool_active_nth );
+                KMP_TEST_THEN_INC32( (kmp_int32 *) &__kmp_thread_pool_active_nth );
                 th->th.th_active_in_pool = TRUE;
             }
         }
@@ -1766,7 +1782,7 @@
     {
         char buffer[128];
         __kmp_print_cond( buffer, &th->th.th_suspend_cv);
-        __kmp_printf( "__kmp_suspend: T#%d has awakened: %s\n", th_gtid, buffer );
+        __kmp_printf( "__kmp_suspend_template: T#%d has awakened: %s\n", th_gtid, buffer );
     }
 #endif
 
@@ -1774,69 +1790,76 @@
     status = pthread_mutex_unlock( &th->th.th_suspend_mx.m_mutex );
     KMP_CHECK_SYSFAIL( "pthread_mutex_unlock", status );
 
-    KF_TRACE( 30, ("__kmp_suspend: T#%d exit\n", th_gtid ) );
+    KF_TRACE( 30, ("__kmp_suspend_template: T#%d exit\n", th_gtid ) );
+}
+
+void __kmp_suspend_32(int th_gtid, kmp_flag_32 *flag) {
+    __kmp_suspend_template(th_gtid, flag);
+}
+void __kmp_suspend_64(int th_gtid, kmp_flag_64 *flag) {
+    __kmp_suspend_template(th_gtid, flag);
+}
+void __kmp_suspend_oncore(int th_gtid, kmp_flag_oncore *flag) {
+    __kmp_suspend_template(th_gtid, flag);
 }
 
 
 /* This routine signals the thread specified by target_gtid to wake up
- * after setting the sleep bit indicated by the spin argument to FALSE.
- * The target thread must already have called __kmp_suspend()
+ * after setting the sleep bit indicated by the flag argument to FALSE.
+ * The target thread must already have called __kmp_suspend_template()
  */
-
-void
-__kmp_resume( int target_gtid, volatile kmp_uint *spin )
+template <class C>
+static inline void __kmp_resume_template( int target_gtid, C *flag )
 {
     kmp_info_t *th = __kmp_threads[target_gtid];
     int status;
-    kmp_uint old_spin;
 
 #ifdef KMP_DEBUG
     int gtid = TCR_4(__kmp_init_gtid) ? __kmp_get_gtid() : -1;
 #endif
 
-    KF_TRACE( 30, ( "__kmp_resume: T#%d wants to wakeup T#%d enter\n",
-                    gtid, target_gtid ) );
-
+    KF_TRACE( 30, ( "__kmp_resume_template: T#%d wants to wakeup T#%d enter\n", gtid, target_gtid ) );
     KMP_DEBUG_ASSERT( gtid != target_gtid );
 
     __kmp_suspend_initialize_thread( th );
 
     status = pthread_mutex_lock( &th->th.th_suspend_mx.m_mutex );
     KMP_CHECK_SYSFAIL( "pthread_mutex_lock", status );
-    if ( spin == NULL ) {
-        spin = (volatile kmp_uint *)TCR_PTR(th->th.th_sleep_loc);
-        if ( spin == NULL ) {
-            KF_TRACE( 5, ( "__kmp_resume: T#%d exiting, thread T#%d already awake -  spin(%p)\n",
-                       gtid, target_gtid, spin ) );
 
-            status = pthread_mutex_unlock( &th->th.th_suspend_mx.m_mutex );
-            KMP_CHECK_SYSFAIL( "pthread_mutex_unlock", status );
-            return;
-        }
+    if (!flag) {
+        flag = (C *)th->th.th_sleep_loc;
     }
 
-    old_spin = KMP_TEST_THEN_AND32( (kmp_int32 volatile *) spin,
-      ~( KMP_BARRIER_SLEEP_STATE ) );
-    if ( ( old_spin & KMP_BARRIER_SLEEP_STATE ) == 0 ) {
-        KF_TRACE( 5, ( "__kmp_resume: T#%d exiting, thread T#%d already awake -  spin(%p): "
-                   "%u => %u\n",
-                   gtid, target_gtid, spin, old_spin, *spin ) );
-
+    if (!flag) {
+        KF_TRACE( 5, ( "__kmp_resume_template: T#%d exiting, thread T#%d already awake: flag(%p)\n",
+                       gtid, target_gtid, NULL ) );
         status = pthread_mutex_unlock( &th->th.th_suspend_mx.m_mutex );
         KMP_CHECK_SYSFAIL( "pthread_mutex_unlock", status );
         return;
     }
+    else {
+        typename C::flag_t old_spin = flag->unset_sleeping();
+        if ( ! flag->is_sleeping_val(old_spin) ) {
+            KF_TRACE( 5, ( "__kmp_resume_template: T#%d exiting, thread T#%d already awake: flag(%p): "
+                           "%u => %u\n",
+                           gtid, target_gtid, flag->get(), old_spin, *flag->get() ) );
+
+            status = pthread_mutex_unlock( &th->th.th_suspend_mx.m_mutex );
+            KMP_CHECK_SYSFAIL( "pthread_mutex_unlock", status );
+            return;
+        }
+        KF_TRACE( 5, ( "__kmp_resume_template: T#%d about to wakeup T#%d, reset sleep bit for flag's loc(%p): "
+                       "%u => %u\n",
+                       gtid, target_gtid, flag->get(), old_spin, *flag->get() ) );
+    }
     TCW_PTR(th->th.th_sleep_loc, NULL);
 
-    KF_TRACE( 5, ( "__kmp_resume: T#%d about to wakeup T#%d, reset sleep bit for spin(%p): "
-                   "%u => %u\n",
-                   gtid, target_gtid, spin, old_spin, *spin ) );
 
 #ifdef DEBUG_SUSPEND
     {
         char buffer[128];
         __kmp_print_cond( buffer, &th->th.th_suspend_cv );
-        __kmp_printf( "__kmp_resume: T#%d resuming T#%d: %s\n", gtid, target_gtid, buffer );
+        __kmp_printf( "__kmp_resume_template: T#%d resuming T#%d: %s\n", gtid, target_gtid, buffer );
     }
 #endif
 
@@ -1845,10 +1868,47 @@
     KMP_CHECK_SYSFAIL( "pthread_cond_signal", status );
     status = pthread_mutex_unlock( &th->th.th_suspend_mx.m_mutex );
     KMP_CHECK_SYSFAIL( "pthread_mutex_unlock", status );
-    KF_TRACE( 30, ( "__kmp_resume: T#%d exiting after signaling wake up for T#%d\n",
+    KF_TRACE( 30, ( "__kmp_resume_template: T#%d exiting after signaling wake up for T#%d\n",
                     gtid, target_gtid ) );
 }
 
+void __kmp_resume_32(int target_gtid, kmp_flag_32 *flag) {
+    __kmp_resume_template(target_gtid, flag);
+}
+void __kmp_resume_64(int target_gtid, kmp_flag_64 *flag) {
+    __kmp_resume_template(target_gtid, flag);
+}
+void __kmp_resume_oncore(int target_gtid, kmp_flag_oncore *flag) {
+    __kmp_resume_template(target_gtid, flag);
+}
+
+void
+__kmp_resume_monitor()
+{
+    KMP_TIME_BLOCK(USER_resume);
+    int status;
+#ifdef KMP_DEBUG
+    int gtid = TCR_4(__kmp_init_gtid) ? __kmp_get_gtid() : -1;
+    KF_TRACE( 30, ( "__kmp_resume_monitor: T#%d wants to wakeup T#%d enter\n",
+                    gtid, KMP_GTID_MONITOR ) );
+    KMP_DEBUG_ASSERT( gtid != KMP_GTID_MONITOR );
+#endif
+    status = pthread_mutex_lock( &__kmp_wait_mx.m_mutex );
+    KMP_CHECK_SYSFAIL( "pthread_mutex_lock", status );
+#ifdef DEBUG_SUSPEND
+    {
+        char buffer[128];
+        __kmp_print_cond( buffer, &__kmp_wait_cv.c_cond );
+        __kmp_printf( "__kmp_resume_monitor: T#%d resuming T#%d: %s\n", gtid, KMP_GTID_MONITOR, buffer );
+    }
+#endif
+    status = pthread_cond_signal( &__kmp_wait_cv.c_cond );
+    KMP_CHECK_SYSFAIL( "pthread_cond_signal", status );
+    status = pthread_mutex_unlock( &__kmp_wait_mx.m_mutex );
+    KMP_CHECK_SYSFAIL( "pthread_mutex_unlock", status );
+    KF_TRACE( 30, ( "__kmp_resume_monitor: T#%d exiting after signaling wake up for T#%d\n",
+                    gtid, KMP_GTID_MONITOR ) );
+}
 
 /* ------------------------------------------------------------------------ */
 /* ------------------------------------------------------------------------ */
@@ -1869,7 +1929,7 @@
 {
     int status;
     KMP_ASSERT( __kmp_init_runtime );
-    status = pthread_setspecific( __kmp_gtid_threadprivate_key, (void*)(gtid+1) );
+    status = pthread_setspecific( __kmp_gtid_threadprivate_key, (void*)(intptr_t)(gtid+1) );
     KMP_CHECK_SYSFAIL( "pthread_setspecific", status );
 }
 
@@ -2022,9 +2082,9 @@
         int mib[] = { CTL_HW, HW_NCPU };
         size_t len = sizeof( r );
         if ( sysctl( mib, 2, &r, &len, NULL, 0 ) < 0 ) {
-            r = 0;
-            KMP_WARNING( CantGetNumAvailCPU );
-            KMP_INFORM( AssumedNumCPU );
+             r = 0;
+             KMP_WARNING( CantGetNumAvailCPU );
+             KMP_INFORM( AssumedNumCPU );
         }
 
     #else
@@ -2268,7 +2328,7 @@
 
     #elif KMP_OS_FREEBSD
 
-        // FIXME(FreeBSD): Implement this.
+        // FIXME(FreeBSD*): Implement this
         found = 1;
 
     #else
diff -uNr openmp-3.5.0.src/runtime/src/z_Windows_NT-586_asm.asm openmp-3.5.0.src.r219214/runtime/src/z_Windows_NT-586_asm.asm
--- openmp-3.5.0.src/runtime/src/z_Windows_NT-586_asm.asm	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/z_Windows_NT-586_asm.asm	2014-10-24 19:58:41.000000000 -0400
@@ -1,7 +1,7 @@
 ;  z_Windows_NT-586_asm.asm:  - microtasking routines specifically
 ;    written for IA-32 architecture and Intel(R) 64 running Windows* OS
-;  $Revision: 42487 $
-;  $Date: 2013-07-08 08:11:23 -0500 (Mon, 08 Jul 2013) $
+;  $Revision: 43373 $
+;  $Date: 2014-08-07 09:17:32 -0500 (Thu, 07 Aug 2014) $
 
 ;
 ;//===----------------------------------------------------------------------===//
@@ -495,121 +495,6 @@
 ___kmp_compare_and_store_ret64 ENDP
 _TEXT     ENDS
 
-
-;------------------------------------------------------------------------
-;
-; FUNCTION ___kmp_test_then_add_real32
-;
-; kmp_real32
-; __kmp_test_then_add_real32( volatile kmp_real32 *addr, kmp_real32 data );
-;
-
-PUBLIC  ___kmp_test_then_add_real32
-_TEXT   SEGMENT
-        ALIGN 16
-_addr$ = 8
-_data$ = 12
-_old_value$ = -4
-_new_value$ = -8
-
-___kmp_test_then_add_real32 PROC NEAR
-        push    ebp
-        mov     ebp, esp
-        sub     esp, 8
-        push    esi
-        push    ebx
-        mov     esi, DWORD PTR _addr$[ebp]
-$L22:
-        fld     DWORD PTR [esi]
-                        ;; load <addr>
-        fst     DWORD PTR _old_value$[ebp]
-                        ;; store into old_value
-        fadd    DWORD PTR _data$[ebp]
-        fstp    DWORD PTR _new_value$[ebp]
-                        ;; new_value = old_value + data
-
-        mov     eax, DWORD PTR _old_value$[ebp]
-                        ;; load old_value
-        mov     ebx, DWORD PTR _new_value$[ebp]
-                        ;; load new_value
-
-lock    cmpxchg DWORD PTR [esi], ebx
-                        ;; Compare EAX with <addr>.  If equal set
-                        ;; ZF and load EBX into <addr>.  Else, clear
-                        ;; ZF and load <addr> into EAX.
-        jnz     SHORT $L22
-
-
-        fld     DWORD PTR _old_value$[ebp]
-                        ;; return old_value
-        pop     ebx
-        pop     esi
-        mov     esp, ebp
-        pop     ebp
-        ret     0
-___kmp_test_then_add_real32 ENDP
-_TEXT     ENDS
-
-;------------------------------------------------------------------------
-;
-; FUNCTION ___kmp_test_then_add_real64
-;
-; kmp_real64
-; __kmp_test_then_add_real64( volatile kmp_real64 *addr, kmp_real64 data );
-;
-
-PUBLIC  ___kmp_test_then_add_real64
-_TEXT   SEGMENT
-        ALIGN 16
-_addr$ = 8
-_data$ = 12
-_old_value$ = -8
-_new_value$ = -16
-
-___kmp_test_then_add_real64 PROC NEAR
-        push    ebp
-        mov     ebp, esp
-        sub     esp, 16
-        push    esi
-        push    ebx
-        push    ecx
-        push    edx
-        mov     esi, DWORD PTR _addr$[ebp]
-$L44:
-        fld     QWORD PTR [esi]
-                        ;; load <addr>
-        fst     QWORD PTR _old_value$[ebp]
-                        ;; store into old_value
-        fadd    QWORD PTR _data$[ebp]
-        fstp    QWORD PTR _new_value$[ebp]
-                        ;; new_value = old_value + data
-
-        mov     edx, DWORD PTR _old_value$[ebp+4]
-        mov     eax, DWORD PTR _old_value$[ebp]
-                        ;; load old_value
-        mov     ecx, DWORD PTR _new_value$[ebp+4]
-        mov     ebx, DWORD PTR _new_value$[ebp]
-                        ;; load new_value
-
-lock    cmpxchg8b QWORD PTR [esi]
-                        ;; Compare EDX:EAX with <addr>.  If equal set
-                        ;; ZF and load ECX:EBX into <addr>.  Else, clear
-                        ;; ZF and load <addr> into EDX:EAX.
-        jnz     SHORT $L44
-
-
-        fld     QWORD PTR _old_value$[ebp]
-                        ;; return old_value
-        pop     edx
-        pop     ecx
-        pop     ebx
-        pop     esi
-        mov     esp, ebp
-        pop     ebp
-        ret     0
-___kmp_test_then_add_real64 ENDP
-_TEXT   ENDS
-
 ;------------------------------------------------------------------------
 ;
 ; FUNCTION ___kmp_load_x87_fpu_control_word
@@ -788,27 +673,6 @@
 
 ;------------------------------------------------------------------------
 ;
-; FUNCTION __kmp_x86_pause
-;
-; void
-; __kmp_x86_pause( void )
-;
-
-PUBLIC  __kmp_x86_pause
-_TEXT   SEGMENT
-        ALIGN 16
-__kmp_x86_pause PROC ;NEAR
-
-        db      0f3H
-        db      090H    ; pause
-        ret
-
-__kmp_x86_pause ENDP
-_TEXT   ENDS
-
-
-;------------------------------------------------------------------------
-;
 ; FUNCTION __kmp_x86_cpuid
 ;
 ; void
@@ -1340,93 +1204,6 @@
 __kmp_xchg_real64 ENDP
 _TEXT   ENDS
 
-
-;------------------------------------------------------------------------
-;
-; FUNCTION __kmp_test_then_add_real32
-;
-; kmp_real32
-; __kmp_test_then_add_real32( volatile kmp_real32 *addr, kmp_real32 data );
-;
-; parameters:
-;	addr:	rcx
-;	data:	xmm1 (lower 4 bytes)
-;
-; return:	xmm0 (lower 4 bytes)
-
-PUBLIC  __kmp_test_then_add_real32
-_TEXT   SEGMENT
-        ALIGN 16
-
-__kmp_test_then_add_real32 PROC ;NEAR
-$__kmp_real32_loop:
-        movss   xmm0, DWORD PTR [rcx]	; load value at <addr>
-	movd	eax, xmm0		; save old value at <addr>
-
-	addss	xmm0, xmm1		; new value = old value + <data>
-	movd	edx, xmm0		; move new value to GP reg.
-
-lock    cmpxchg DWORD PTR [rcx], edx
-                        ; Compare EAX with <addr>.  If equal set
-                        ; ZF and exchange EDX with <addr>.  Else, clear
-                        ; ZF and load <addr> into EAX.
-        jz     	SHORT $__kmp_real32_success
-
-        db      0f3H
-        db      090H    		; pause
-
-	jmp	SHORT $__kmp_real32_loop
-
-$__kmp_real32_success:
-	movd	xmm0, eax		; load old value into return register
-        ret
-__kmp_test_then_add_real32 ENDP
-_TEXT     ENDS
-
-
-;------------------------------------------------------------------------
-;
-; FUNCTION __kmp_test_then_add_real64
-;
-; kmp_real64
-; __kmp_test_then_add_real64( volatile kmp_real64 *addr, kmp_real64 data );
-;
-; parameters:
-;	addr:	rcx
-;	data:	xmm1 (lower 8 bytes)
-;
-; return:	xmm0 (lower 8 bytes)
-
-PUBLIC  __kmp_test_then_add_real64
-_TEXT   SEGMENT
-        ALIGN 16
-
-__kmp_test_then_add_real64 PROC ;NEAR
-$__kmp_real64_loop:
-        movlpd  xmm0, QWORD PTR [rcx]	; load value at <addr>
-	movd	rax, xmm0		; save old value at <addr>
-
-	addsd	xmm0, xmm1		; new value = old value + <data>
-	movd	rdx, xmm0		; move new value to GP reg.
-
-lock    cmpxchg QWORD PTR [rcx], rdx
-                        ; Compare RAX with <addr>.  If equal set
-                        ; ZF and exchange RDX with <addr>.  Else, clear
-                        ; ZF and load <addr> into RAX.
-        jz     	SHORT $__kmp_real64_success
-
-        db      0f3H
-        db      090H    		; pause
-
-	jmp	SHORT $__kmp_real64_loop
-
-$__kmp_real64_success:
-	movd	xmm0, rax		; load old value into return register
-        ret
-__kmp_test_then_add_real64 ENDP
-_TEXT   ENDS
-
-
 ;------------------------------------------------------------------------
 ;
 ; FUNCTION __kmp_load_x87_fpu_control_word
diff -uNr openmp-3.5.0.src/runtime/src/z_Windows_NT-586_util.c openmp-3.5.0.src.r219214/runtime/src/z_Windows_NT-586_util.c
--- openmp-3.5.0.src/runtime/src/z_Windows_NT-586_util.c	2013-09-27 06:38:44.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/z_Windows_NT-586_util.c	2014-10-24 19:58:41.000000000 -0400
@@ -1,7 +1,7 @@
 /*
  * z_Windows_NT-586_util.c -- platform specific routines.
- * $Revision: 42181 $
- * $Date: 2013-03-26 15:04:45 -0500 (Tue, 26 Mar 2013) $
+ * $Revision: 42951 $
+ * $Date: 2014-01-21 14:41:41 -0600 (Tue, 21 Jan 2014) $
  */
 
 
